<?php
/***************************************************************
*  Copyright notice
*
*  (c) 1999-2003 Kasper Skaarhoej (kasper@typo3.com)
*  (c) 2004-2005 Stanislas Rolland (stanislas.rolland@fructifor.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

/**
 * Plugin 'Language Selection' for the 'sr_language_menu' extension.
 *
 * @author	Kasper Skaarhoej <kasper@typo3.com>
 * @coauthor	Stanislas Rolland <stanislas.rolland@fructifor.com>
 */

require_once(PATH_tslib.'class.tslib_pibase.php');
require_once(t3lib_extMgm::extPath('sr_static_info').'pi1/class.tx_srstaticinfo_pi1.php');

class tx_srlanguagemenu_pi1 extends tslib_pibase {
	var $prefixId = 'tx_srlanguagemenu_pi1';			// Same as class name
	var $scriptRelPath = 'pi1/class.tx_srlanguagemenu_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'sr_language_menu';				// The extension key.
	var $conf = array();
	var $cObj;

	/**
	 * The constructor returns the language menu
	 * 
	 * @param	string		$content: HTML content
	 * @param	array		$conf: The mandatory configuration array
	 * @return	void		
	 */

	function main($content,$conf)	{	

		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->linkVars = $GLOBALS['TSFE']->linkVars;
		$this->typoVersion = t3lib_div::int_from_ver($GLOBALS['TYPO_VERSION']);

		$this->staticInfo = t3lib_div::makeInstance('tx_srstaticinfo_pi1');
		$this->staticInfo->init();

		$useSysLanguageTitle = trim($this->conf['useSysLanguageTitle']) ? trim($this->conf['useSysLanguageTitle']) : 0;
		$useIsoLanguageCountryCode = trim($this->conf['useIsoLanguageCountryCode']) ? trim($this->conf['useIsoLanguageCountryCode']) : 0;
		$useIsoLanguageCountryCode = $useSysLanguageTitle ? 0 : $useIsoLanguageCountryCode;
		$useSelfLanguageTitle = trim($this->conf['useSelfLanguageTitle']) ? trim($this->conf['useSelfLanguageTitle']) : 0;
		$useSelfLanguageTitle = ($useSysLanguageTitle || $useIsoLanguageCountryCode) ? 0 : $useSelfLanguageTitle;

		$this->realUrlLoaded = t3lib_extMgm::isLoaded('realurl', 0);
		$this->rlmp_language_detectionLoaded = t3lib_extMgm::isLoaded('rlmp_language_detection', 0);

		$localTempl = new t3lib_TStemplate;

		$removeParams = t3lib_div::trimExplode(',', $this->conf['removeParams'], 1);
		$forwardParams = $this->local_add_vars($GLOBALS['HTTP_GET_VARS'],$removeParams);
		$forwardParams .= $this->local_add_vars($GLOBALS['HTTP_POST_VARS'],$removeParams);
		$GLOBALS['TSFE']->linkVars = $this->remove_vars($GLOBALS['TSFE']->linkVars,$removeParams);

		$tableA = 'sys_language';
		$tableB = 'static_languages';

		$defaultLanguageISOCode = trim($this->conf['defaultLanguageISOCode']) ?  strtoupper(trim($this->conf['defaultLanguageISOCode'])) : 'EN';
		$defaultCountryISOCode = trim($this->conf['defaultCountryISOCode']) ?  strtoupper(trim($this->conf['defaultCountryISOCode'])) : '';
		$languagesUidsList = trim($this->cObj->data['tx_srlanguagemenu_languages']) ? trim($this->cObj->data['tx_srlanguagemenu_languages']) : trim($this->conf['languagesUidsList']);
		$languages = array();
		$languages[] = strtolower($defaultLanguageISOCode).($defaultCountryISOCode?'_'.$defaultCountryISOCode:'');
		$languagesUids = array();
		$languagesUids[] = '0';
		$languagesLabels = array();
		if($useIsoLanguageCountryCode) {
			$languagesLabels[] = strtolower($defaultLanguageISOCode).($defaultCountryISOCode?'-'.strtolower($defaultCountryISOCode):'');
		} else {
			$languagesLabels[] = $this->staticInfo->getStaticInfoName('LANGUAGES', strtoupper($languages['0']),'','',$useSelfLanguageTitle);
		}

			// Get the language codes and labels for the languages set in the plugin list
		$selectFields = $tableA . '.uid, ' . $tableA . '.title, ' . $tableB . '.lg_iso_2, ' . $tableB . '.lg_name_en, ' . $tableB . '.lg_country_iso_2';
		$table = $tableA . ' LEFT JOIN ' . $tableB . ' ON ' . $tableA . '.static_lang_isocode=' . $tableB . '.uid';
			// <Francois Suter> Ignore IN clause if language list is empty. This means that all languages found in the sys_language table will be used
		if (!empty($languagesUidsList)) {
			$whereClause = $tableA . '.uid IN (' . $languagesUidsList . ') ';
		}else {
			$whereClause = '1=1 ';
		}
			// </Francois Suter>
		$whereClause .= $this->cObj->enableFields ($tableA);
		$whereClause .= $this->cObj->enableFields ($tableB);
		if($this->typoVersion >= 3006000) {
			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery($selectFields, $table, $whereClause);
		} else {
			$query  = 'SELECT ' . $selectFields . ' FROM ' . $table . ' WHERE ' . $whereClause;
			$res = mysql(TYPO3_db,$query);
			echo mysql_error();
		}
		while($row = (($this->typoVersion >= 3006000) ? $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res) : mysql_fetch_assoc($res)))   {
			if ($row['lg_iso_2'] != $defaultLanguageISOCode || $row['lg_country_iso_2'] != $defaultCountryISOCode) {
				$languagesUids[] = $row['uid'];
				$languages[] = strtolower($row['lg_iso_2']).($row['lg_country_iso_2']?'_'.$row['lg_country_iso_2']:'');
				if ($useIsoLanguageCountryCode) {
					$languagesLabels[] =  strtolower($row['lg_iso_2']).($row['lg_country_iso_2']?'-'.strtolower($row['lg_country_iso_2']):'');
				} elseif ($useSysLanguageTitle) {
					$languagesLabels[] =  $row['title'];
				} else {
					$languagesLabels[] =  $this->staticInfo->getStaticInfoName('LANGUAGES', $row['lg_iso_2'].($row['lg_country_iso_2']?'_'.$row['lg_country_iso_2']:''),'','',$useSelfLanguageTitle);
				}
			} elseif($useSysLanguageTitle) {
					$languagesLabels['0'] =  $row['title'];
			}
		}

			// Select all pages_language_overlay records on the current page. Each represents a possibility for a language.
		$langArr=array();
		$table = 'pages_language_overlay';
		$whereClause = 'pid="' . $GLOBALS['TSFE']->id . '" ';
		$whereClause .= $GLOBALS['TSFE']->sys_page->enableFields($table);
		if ($this->typoVersion >= 3006000) {
			$groupBy = $GLOBALS['TYPO3_DB']->quoteStr('sys_language_uid', $table);
			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', $table, $whereClause, $groupBy);
		} else {
			$query = 'SELECT * FROM ' . $table . ' WHERE ' . $whereClause . ' GROUP BY sys_language_uid';
			$res = mysql(TYPO3_db,$query);
		}
		while($row = (($this->typoVersion >= 3006000) ? $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res) : mysql_fetch_assoc($res)))	{
			$langArr[$row['sys_language_uid']] = $row['sys_language_uid'];
		}

		// <Ian Foulds> Do not show the language selector if no alt languages present
		if(!$this->conf['hideIfNoAltLanguages'] || (count($langArr) > 0)) {
		// </Ian Foulds>
				// get the template
			$this->templateCode = $this->cObj->fileResource($this->conf['templateFile']);

				// initialize linkvars
			if(!$this->realUrlLoaded) {
				if(strstr($GLOBALS['TSFE']->linkVars, '&L=')) {
					$GLOBALS['TSFE']->linkVars = ereg_replace('&L=[0-9]*' , '', $GLOBALS['TSFE']->linkVars);
				}
				if(!$this->rlmp_language_detectionLoaded) $GLOBALS['TSFE']->linkVars = ereg_replace('&L=0' , '', $GLOBALS['TSFE']->linkVars);
				$LD = $localTempl->linkData($GLOBALS['TSFE']->page,'','','','',$forwardParams,'0');
				$uri = $LD['totalURL'];
			}

				// get the specified layout
			$layout = $this->cObj->data['tx_srlanguagemenu_type'] ? $this->cObj->data['tx_srlanguagemenu_type'] : trim($this->conf['defaultLayout']);
			switch ($layout) {
				case 1:

					$templateMarker = '###TEMPLATE_1###';
					$template = $this->cObj->getSubpart($this->templateCode, $templateMarker);
					$subpartArray = array();

					$selected = '';
					$this->selectorEmpty = true;
					reset($languages);
					while( list($key,$val) = each($languages)) {
						if($this->realUrlLoaded) {
							if(strstr($GLOBALS['TSFE']->linkVars, '&L=')) {            
								$GLOBALS['TSFE']->linkVars = ereg_replace('&L=[0-9]*' , '&L='.$languagesUids[$key], $GLOBALS['TSFE']->linkVars);
							} else {
								$GLOBALS['TSFE']->linkVars .= '&L='.$languagesUids[$key];
							}
							$LD = $localTempl->linkData($GLOBALS['TSFE']->page,'','','','',$forwardParams,'0');
							$uri = $LD['totalURL'];
							if(!$key || $langArr[$languagesUids[$key]]) {
								$names['/'.$uri] = $languagesLabels[$key];
								$selected = ($GLOBALS['TSFE']->sys_language_uid==$languagesUids[$key])?'/'.$uri: $selected;
							}
						} else {
							if(!$key || $langArr[$languagesUids[$key]]) {
								$names[$languagesUids[$key]] = $languagesLabels[$key];
								$selected = ($GLOBALS['TSFE']->sys_language_uid==$languagesUids[$key])?$languagesUids[$key]: $selected;
							}
						}
					}

					$questionMark = strstr($uri, '?') ? '' : '?';
					if(!$this->realUrlLoaded) {
						$subpartArray['###LANGUAGE_SELECT###'] =  $this->buildLanguageSelector($names, 'L', '', $this->pi_getLL('select_language'), $selected, 'if(' . ($this->rlmp_language_detectionLoaded?'true':'false') . ' || document.sr_language_menu_form.L.options[document.sr_language_menu_form.L.selectedIndex].value != \'0\') { top.location.replace(\'' . htmlspecialchars($uri . $questionMark . '&L=') . '\' + document.sr_language_menu_form.L.options[document.sr_language_menu_form.L.selectedIndex].value ); } else { top.location.replace(\'' . htmlspecialchars($uri) .  '\'); }' );
					} else {
						$subpartArray['###LANGUAGE_SELECT###'] =  $this->buildLanguageSelector($names, 'L', '', $this->pi_getLL('select_language'), $selected, 'top.location.replace(document.sr_language_menu_form.L.options[document.sr_language_menu_form.L.selectedIndex].value );' );
					}
					if(!$this->selectorEmpty) {
						$subpartArray['###LANGUAGE_SELECT###'] = '<form action="" name="sr_language_menu_form">' . $subpartArray['###LANGUAGE_SELECT###'] . '</form>';
					} else {
						$subpartArray['###LANGUAGE_SELECT###'] = ' ';
					}

					$content = $this->cObj->substituteMarkerArrayCached($template, $subpartArray, array(), array());
					break;

				case 2:

					// <Francois Suter> List of links display option
					$templateMarker = '###TEMPLATE_2###';
					$template = $this->cObj->getSubpart($this->templateCode, $templateMarker);
					$subpartArray = array();
					$subpartArray['###LINK_LIST###'] = '';
					$linkEntrySubpart = $this->cObj->getSubpart($template, '###LINK_ENTRY###');
					$markerArray = array();

					$firstItem = true;
					reset($languages);
					while( list($key,$val) = each($languages)) {
						if(strstr($GLOBALS['TSFE']->linkVars, '&L=')) {
							$GLOBALS['TSFE']->linkVars = ereg_replace('&L=[0-9]*' , '&L='.$languagesUids[$key], $GLOBALS['TSFE']->linkVars);
						} else {
							$GLOBALS['TSFE']->linkVars .= '&L='.$languagesUids[$key];
						}
						if(!$this->rlmp_language_detectionLoaded) $GLOBALS['TSFE']->linkVars = ereg_replace('&L=0' , '', $GLOBALS['TSFE']->linkVars);
						$LD = $localTempl->linkData($GLOBALS['TSFE']->page,'','','','',$forwardParams,'0');
						$uri = $LD['totalURL'];
						$label = $languagesLabels[$key];
						$item = '<a href="' . htmlspecialchars($uri) . (trim($this->conf['target']) ? ('" target="' . trim($this->conf['target']) . '"') : '') . '">'.$label.'</a>';
						if( $GLOBALS['TSFE']->sys_language_uid==$languagesUids[$key] ) {
							$item = ($this->conf['link.']['CUR.']['stdWrap.']) ? $this->cObj->stdWrap($item, $this->conf['link.']['CUR.']['stdWrap.']) : $item;
						} elseif ($key && !$langArr[$languagesUids[$key]]) {
							$item = ($this->conf['link.']['INACT.']['stdWrap.']) ? $this->cObj->stdWrap($item, $this->conf['link.']['INACT.']['stdWrap.']) : $item;
						} else {
							$item = ($this->conf['link.']['NO.']['stdWrap.']) ? $this->cObj->stdWrap($item, $this->conf['link.']['NO.']['stdWrap.']) : $item;
						}
						if (!empty($item) && !$firstItem)  $item = ' ' . ($this->conf['links.']['stdWrap.']['split.']['token']?$this->conf['links.']['stdWrap.']['split.']['token']:'|') . ' ' . $item;
						$firstItem = (!empty($item)) ? false : $firstItem;
						$markerArray['###LINK###'] = $item;
						$subpartArray['###LINK_LIST###'] .= $this->cObj->substituteMarkerArrayCached($linkEntrySubpart, $markerArray, array(), array());
					}
					$subpartArray['###LINK_LIST###'] = ($this->conf['links.']['stdWrap.']) ? $this->cObj->stdWrap($subpartArray['###LINK_LIST###'], $this->conf['links.']['stdWrap.'])  : $subpartArray['###LINK_LIST###'];
					$content = $this->cObj->substituteMarkerArrayCached($template, $markerArray, $subpartArray, array());
					break;
					// </Francois Suter>

				case 0:
				default:

					$templateMarker = '###TEMPLATE_0###';
					$template = $this->cObj->getSubpart($this->templateCode, $templateMarker);
					$subpartArray = array();
					$subpartArray['###FLAG_LIST###'] = '';
					$flagEntrySubpart = $this->cObj->getSubpart($template, '###FLAG_ENTRY###');
					$markerArray = array();

					if( trim($this->conf['englishFlagFile']) ) {
						$flagsDir = dirname($GLOBALS['TSFE']->tmpl->getFileName(trim($this->conf['englishFlagFile']))).'/';
					}
					if( !$flagsDir ) {
						$flagsDir = t3lib_extMgm::extPath($this->extKey).'flags/';
					}

						// Set each icon. If the language is the current, red arrow is printed to the left. If the language is NOT found, the icon is dimmed.
					$flags = array();
					$firstItem = true;
					reset($languages);
					while( list($key,$val) = each($languages)) {
						if(strstr($GLOBALS['TSFE']->linkVars, '&L=')) {
							$GLOBALS['TSFE']->linkVars = ereg_replace('&L=[0-9]*' , '&L='.$languagesUids[$key], $GLOBALS['TSFE']->linkVars);
						} else {
							$GLOBALS['TSFE']->linkVars .= '&L='.$languagesUids[$key];
						}
						if(!$this->rlmp_language_detectionLoaded) $GLOBALS['TSFE']->linkVars = ereg_replace('&L=0' , '', $GLOBALS['TSFE']->linkVars);
						$LD = $localTempl->linkData($GLOBALS['TSFE']->page,'','','','',$forwardParams,'0');
						$uri = $LD['totalURL'];
						$item = '<a href="' . htmlspecialchars($uri) . (trim($this->conf['target']) ? ('" target="' . trim($this->conf['target']) . '"') : '') . '"><img src="' . $flagsDir .($this->conf['alternateFlags.'][$languages[$key]]?$this->conf['alternateFlags.'][$languages[$key]]:$languages[$key]).((!$key || $langArr[$languagesUids[$key]])?'':'_d') . '.gif" style="width: 21px; height: 13px;" title="'.$languagesLabels[$key].'" alt="'.$languagesLabels[$key].'" /></a>';
						if( $GLOBALS['TSFE']->sys_language_uid==$languagesUids[$key] ) {
							$item = ($this->conf['flag.']['CUR.']['stdWrap.']) ? $this->cObj->stdWrap($item, $this->conf['flag.']['CUR.']['stdWrap.']) : $item;
						} elseif ($key && !$langArr[$languagesUids[$key]]) {
							$item = ($this->conf['flag.']['INACT.']['stdWrap.']) ? $this->cObj->stdWrap($item, $this->conf['flag.']['INACT.']['stdWrap.']) : $item;
						} else {
							$item = ($this->conf['flag.']['NO.']['stdWrap.']) ? $this->cObj->stdWrap($item, $this->conf['flag.']['NO.']['stdWrap.']) : $item;
						}
						if (!empty($item) && !$firstItem)  $item = ' ' . ($this->conf['flags.']['stdWrap.']['split.']['token']?$this->conf['flags.']['stdWrap.']['split.']['token']:'|') . ' ' . $item;
						$firstItem = (!empty($item)) ? false : $firstItem;
						$markerArray['###FLAG###'] = $item;
						$subpartArray['###FLAG_LIST###'] .= $this->cObj->substituteMarkerArrayCached($flagEntrySubpart, $markerArray, array(), array());
					}
					$subpartArray['###FLAG_LIST###'] = ($this->conf['flags.']['stdWrap.']) ? $this->cObj->stdWrap($subpartArray['###FLAG_LIST###'], $this->conf['flags.']['stdWrap.'])  : $subpartArray['###FLAG_LIST###'];
					$content = $this->cObj->substituteMarkerArrayCached($template, $markerArray, $subpartArray, array());
			}
			
		// <Ian Foulds>
		}
		// </Ian Foulds>	

		$GLOBALS['TSFE']->linkVars = $this->linkVars;
		return $this->pi_wrapInBaseClass($content);

	} // end of main

	function local_add_vars2($vars,$path) {
		$res='';
		reset ($vars);
		while (list ($key, $val) = each ($vars)) {
			if (!is_array($val)) {
				$res .= '&'.$path.'['.rawurlencode($key).']'.'='.rawurlencode($val);
			} else {
	  			$res .= $this->local_add_vars2($val, $path.'['.rawurlencode($key).']');
			}
		}
		return $res;
	}

	function local_add_vars($vars,$varNames) {
		$res='';
		reset ($vars);
		while (list ($key, $val) = each ($vars)) {
			if (is_array($val)) {
	  			$res .= $this->local_add_vars2($val, rawurlencode($key));
			} else {
				if (($key != 'id') && ($key != 'type') && ($key != 'L') && !in_array($key,$varNames)) {
					$res .= '&'.rawurlencode($key).'='.rawurlencode($val);
				}
			}
		}
		return $res;
	}

	function remove_vars($linkVars,$varNames) {
		$newLinkVars='';
		if (strcmp($linkVars,'')) {
			$p = explode('&',$linkVars);
			foreach($p as $k => $v) {
				if ((string)$v) {
					list($pName) = explode('=',$v,2);
					if(in_array($pName,$varNames)) unset($p[$k]);
				} else unset($p[$k]);
			}
		$newLinkVars = count($p) ? '&'.implode('&',$p) : '';
		}
		return $newLinkVars;
	}

	/**
	 * Buils a HTML drop-down selector of languages
	 *
	 * @param	array		An array where the values will be the texts of an <option> tags and keys will be the values of the tags
	 * @param	string		A value for the name attribute of the <select> tag
	 * @param	string		A value for the class attribute of the <select> tag
	 * @param	string		A value for the title attribute of the <select> tag
	 * @param	string		The value of the code of the entry to be pre-selected in the drop-down selector
	 * @param	boolean/string	If set to 1, an onchange attribute will be added to the <select> tag for immediate submit of the changed value; if set to other than 1, overrides the onchange script
	 * @return	string		A set of HTML <select> and <option> tags
	 */

	function buildLanguageSelector($names, $name='L', $class='', $title='', $selected='', $submit=0)	{
		$nameAttribute = (trim($name)) ? 'name="'.trim($name).'" ' : '';
		$classAttribute = (trim($class)) ? 'class="'.trim($class).'" ' : '';
		$titleAttribute = (trim($title)) ? 'title="'.trim($title).'" ' : '';
		$onchangeAttribute = '';
		
		if( $submit ) {
			if( $submit == 1 ) {
				$onchangeAttribute = 'onchange="'.trim($this->conf['onChangeAttribute']).'" ';
			} else {
					// <Masi>
				$onchangeAttribute = 'onchange="';
				if ($this->conf['list.']['header']) {
					$onchangeAttribute .= 'if (document.sr_language_menu_form.L.options[document.sr_language_menu_form.L.selectedIndex].value == \'\') return;';
				}
				$onchangeAttribute .= $submit.'" ';
					// </Masi>
			}
		}

		$selector = '<select size="1" '.$nameAttribute.$classAttribute.$titleAttribute.$onchangeAttribute.'>'.chr(10);
		$selected = (trim($selected)) ? trim($selected) : '';
		reset($names);
		$selected = $selected ? $selected : key($names);
		if( count($names) > 0 )	{
			$selector .= $this->optionsConstructor($names, $selected);
			$selector .= '</select>'.chr(10);
		} else {
			$selector = '';
		}
		return $selector;
	}

	/**
	 * Builds a list of <option> tags
	 *
	 * @param	array		An array where the values will be the texts of an <option> tags and keys will be the values of the tags
	 * @param	string		A pre-selected value: if the value appears as a key, the <option> tag will bear a 'selected' attribute
	 * @return	string		A string of HTML <option> tags
	 */

	function optionsConstructor($names, $selected='') {
		$options = '';
			// <Masi>
		if ($this->conf['list.']['header'])	{
			$options .= '<option value ="">'.$this->pi_getLL('select_language').'</option>';
			if ($this->conf['list.']['separator'])	{
				$options .= '<option value ="">'.$this->conf['list.']['separator'].'</option>';
			}
		}
			// </Masi>
		reset($names);
		while(list($value,$name)=each($names))	{
				// don't show current language if showCurrent=0
			if($selected != $value || $this->conf['list.']['showCurrent']) {
				$options  .= '<option value="'.$value.'"';
					// don't pre-select language when using a header
				if (!$this->conf['list.']['header'] && $selected == $value) {
					$options  .= ' selected="selected"';
				}
				$options  .= '>'.$name.'</option>'.chr(10);
				$this->selectorEmpty = false;
			}
		}
		return $options;
	}

} // end of class

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sr_language_menu/pi1/class.tx_srlanguagemenu_pi1.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/sr_language_menu/pi1/class.tx_srlanguagemenu_pi1.php"]);
}

?>